package meerkat.crypto;

import com.google.protobuf.Message;

import java.security.MessageDigest;

/**
 * Created by talm on 11/9/15.
 */
public interface Digest {
    /**
     * Completes the hash computation by performing final operations such as padding.
     * (copied from {@link MessageDigest#digest()})
     * @return
     */
    byte[] digest();

    /**
     * Updates the digest using the specified message (in serialized wire form)
     *
     * Each message is (automatically) prepended with its length as a 32-bit big-endian unsigned integer.
     * @param msg
     * @return
     */
    void update(Message msg);

    /**
     * Resets the digest for further use.
     */
    void reset();

    /**
     * Clone the current digest state
     * @return
     */
    public Digest clone() throws CloneNotSupportedException;

}
