package meerkat.crypto.mixnet;

import meerkat.protobuf.Crypto;
import meerkat.protobuf.Mixing;

/**
 * Prove in zero knowledge that two ciphertexts are a mix of two original ciphertexts.
 */
public interface Mix2ZeroKnowledgeProver {
    public Mixing.ZeroKnowledgeProof prove(Crypto.RerandomizableEncryptedMessage in1,
                                           Crypto.RerandomizableEncryptedMessage in2,
                                           Crypto.RerandomizableEncryptedMessage out1,
                                           Crypto.RerandomizableEncryptedMessage out2,
                                           boolean switched,
                                           Crypto.EncryptionRandomness r1,
                                           Crypto.EncryptionRandomness r2);

}
