package meerkat.crypto.mixnet;

import meerkat.protobuf.Crypto;
import meerkat.protobuf.Mixing;

/**
 * Verify the two-ciphertext mix proof
 */
public interface Mix2ZeroKnowledgeVerifier {
    /**
     * Return true iff the proof is valid.
     * @param in1
     * @param in2
     * @param out1
     * @param out2
     * @return
     */
    boolean verify(Crypto.RerandomizableEncryptedMessage in1,
                   Crypto.RerandomizableEncryptedMessage in2,
                   Crypto.RerandomizableEncryptedMessage out1,
                   Crypto.RerandomizableEncryptedMessage out2,
                   Mixing.ZeroKnowledgeProof proof);
}
