package meerkat.voting;

import java.io.IOException;
import java.util.Random;

import com.google.protobuf.ByteString;
import com.google.protobuf.InvalidProtocolBufferException;
import com.google.protobuf.Message;

import meerkat.crypto.Encryption;
import meerkat.protobuf.Crypto.EncryptionPublicKey;
import meerkat.protobuf.Crypto.EncryptionRandomness;
import meerkat.protobuf.Crypto.RerandomizableEncryptedMessage;
import sun.reflect.generics.reflectiveObjects.NotImplementedException;

public class EncryptionFake implements Encryption {
	
	EncryptionPublicKey m_encryptionPublicKey;
	Random m_rnd;
	
	public EncryptionFake (EncryptionPublicKey publicKey) {
		m_encryptionPublicKey = publicKey;
	}

	@Override
	public RerandomizableEncryptedMessage encrypt(Message plaintext, EncryptionRandomness rnd) throws IOException {
		// TODO Auto-generated method stub
		assert plaintext != null;
		assert rnd != null;

		byte plaintextBytes[] = plaintext.toByteArray();
		byte encryptedBytes[] = new byte[plaintextBytes.length + 1];
		encryptedBytes[0] = rnd.getData().byteAt(0);
		for (int i = 0; i < plaintextBytes.length; ++i) {
			encryptedBytes[i+1] = (byte)(plaintextBytes[i] ^ encryptedBytes[0]);
		}
		
		return RerandomizableEncryptedMessage.newBuilder().setData(ByteString.copyFrom(encryptedBytes)).build();
	}

	@Override
	public RerandomizableEncryptedMessage rerandomize(RerandomizableEncryptedMessage msg, EncryptionRandomness rnd)
			throws InvalidProtocolBufferException {
		// TODO Auto-generated method stub
		System.err.println("rerandomize: not implemented!");
		throw new NotImplementedException();
	}

	@Override
	public EncryptionRandomness generateRandomness(Random rand) {
		assert rand != null;
		byte a[] = new byte[1];
		a[0] = (byte)((rand.nextInt() % 255)+1);
		ByteString val = ByteString.copyFrom(a);
		return EncryptionRandomness.newBuilder().setData(val).build();
	}

}
