package meerkat.voting;

import meerkat.protobuf.Voting.EncryptedBallot;

public class SharedEncryptedBallotMessage {

	   private EncryptedBallot m_encryptedBallot;
	   private boolean b_writeable = true;

	   synchronized void setSharedMessage (EncryptedBallot encryptedBallot)
	   {
	      while (!b_writeable) {
	         try
	         {
	            wait ();
	         }
	         catch (InterruptedException e) {}
	      }

	      m_encryptedBallot = EncryptedBallot.newBuilder(encryptedBallot).build();
	      b_writeable = false;
	      notifyAll ();
	   }

	   synchronized EncryptedBallot getSharedMessage (int millisecTimeout)
	   {
		   do {
			   try {
				   wait (millisecTimeout);
			   }
			   catch (InterruptedException e) { }
		   } while (b_writeable && millisecTimeout == 0);

	       EncryptedBallot retValue = null;
	      
	       if (m_encryptedBallot != null) 
	       {
		       b_writeable = true;
		       notifyAll ();
		       retValue = EncryptedBallot.newBuilder(m_encryptedBallot).build();
		       m_encryptedBallot = null;
	       }
		  
	       return retValue;
	   }

}
