package meerkat.voting;

import com.google.protobuf.ByteString;

import meerkat.protobuf.Crypto.SignatureType;
import meerkat.protobuf.Crypto.SignatureVerificationKey;
import meerkat.protobuf.Voting.BoothParams;
import meerkat.protobuf.Voting.ElectionParams;

public class VotingBoothToyDemoRun {

	static int N_SIGNATURE_VERIFICATION_KEYS = 3;
	
	public static void main (String[] args)
	{
		VotingBoothToy vbController = new VotingBoothToy ();
		VotingBoothToyConsoleUI ui = new VotingBoothToyConsoleUI();

		vbController.registerUI (ui);
		ui.registerVBController(vbController);
		
		BoothParams.Builder bpb = BoothParams.newBuilder();
		SignatureType signatureType = SignatureType.ECDSA;
		for (int i = 0; i < N_SIGNATURE_VERIFICATION_KEYS; ++i) {
			SignatureVerificationKey verifiationKey = SignatureVerificationKey.newBuilder()
														.setType(signatureType)
														.setData(ByteString.copyFrom(new byte[0]))
														.build();
			bpb.addPscVerificationKeys(i, verifiationKey);
		}
		BoothParams boothParams = bpb.build();
		
		ElectionParams electionParams = new ElectionParams();
		
		vbController.init(electionParams, boothParams);
		
		Thread controllerThread = new Thread(new VotingBoothToy ());
		Thread uiThread = new Thread(ui);

		controllerThread.start();
		uiThread.start();
		
	}

}
